<?php
/**
 * Kids Toy Center Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package kids_toy_center
 */

if( ! function_exists( 'kids_toy_center_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function kids_toy_center_customize_register( $wp_customize ) {
    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'kids-toy-center' );
    }

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Kids_Toy_Center_Control_Sortable' ); 
	
    /* Option list of all post */	
    $kids_toy_center_options_posts = array();
    $kids_toy_center_options_posts_obj = get_posts('posts_per_page=-1');
    $kids_toy_center_options_posts[''] = esc_html__( 'Choose Post', 'kids-toy-center' );
    foreach ( $kids_toy_center_options_posts_obj as $kids_toy_center_posts ) {
    	$kids_toy_center_options_posts[$kids_toy_center_posts->ID] = $kids_toy_center_posts->post_title;
    }
    
    /* Option list of all categories */
    $kids_toy_center_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $kids_toy_center_option_categories = array();
    $kids_toy_center_category_lists = get_categories( $kids_toy_center_args );
    $kids_toy_center_option_categories[''] = esc_html__( 'Choose Category', 'kids-toy-center' );
    foreach( $kids_toy_center_category_lists as $kids_toy_center_category ){
        $kids_toy_center_option_categories[$kids_toy_center_category->term_id] = $kids_toy_center_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'kids-toy-center' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'kids-toy-center' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */

     /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'kids-toy-center' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'kids-toy-center' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'kids-toy-center'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

        /** Responsive Media settings */
    
    $wp_customize->add_section(
        'kids_toy_center_responsive_media_section',
        array(
            'title' => esc_html__( 'Responsive Media Settings', 'kids-toy-center' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_general_settings',
        )
    );

    /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'kids_toy_center_resp_scroll_top', 
        array(
            'default' => 1,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_resp_scroll_top',
        array(
            'label'       => __( 'Show Scroll To Top', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

        /** Scroll to top Responsive control */
    $wp_customize->add_setting( 
        'kids_toy_center_resp_loader', 
        array(
            'default' => 0,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_resp_loader',
        array(
            'label'       => __( 'Show Preloader', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_responsive_media_section',
            'type'        => 'checkbox',
        )
    );

    /** Responsive Media Ends */

    //Global Color
    $wp_customize->add_section(
        'kids_toy_center_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'kids-toy-center' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_general_settings',
        )
    );

    $wp_customize->add_setting('kids_toy_center_primary_color', array(
        'default'           => '#AC82E1',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'kids_toy_center_primary_color', array(
        'label'    => __('Theme Primary Color', 'kids-toy-center'),
        'section'  => 'kids_toy_center_global_color',
        'settings' => 'kids_toy_center_primary_color',
    )));    

    $wp_customize->add_setting('kids_toy_center_second_color', array(
        'default'           => '#80CAFF',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'kids_toy_center_second_color', array(
        'label'    => __('Theme Tertiary Color', 'kids-toy-center'),
        'section'  => 'kids_toy_center_global_color',
        'settings' => 'kids_toy_center_second_color',
    )));

    $wp_customize->add_setting('kids_toy_center_third_color', array(
        'default'           => '#EB6767',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'kids_toy_center_third_color', array(
        'label'    => __('Theme Third Color', 'kids-toy-center'),
        'section'  => 'kids_toy_center_global_color',
        'settings' => 'kids_toy_center_third_color',
    )));

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'kids_toy_center_home_post_settings',
         array(
            'priority' => 12,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'kids-toy-center' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'kids-toy-center' ),
        ) 
    );

    /** Post Layouts */
    
    $wp_customize->add_section(
        'kids_toy_center_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'kids-toy-center' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_home_post_settings',

        )
    );

    $wp_customize->add_setting('kids_toy_center_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'kids_toy_center_sanitize_post_layout',
    ));

    $wp_customize->add_control('kids_toy_center_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'kids-toy-center'),
        'section'  => 'kids_toy_center_post_layout_section',
        'settings' => 'kids_toy_center_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'kids-toy-center'),
            'left-sidebar'   => __('Left Sidebar', 'kids-toy-center'),
            'one-column'   => __('One Column', 'kids-toy-center'),
            'three-column'   => __('Three Columns', 'kids-toy-center'),
            'four-column'   => __('Four Columns', 'kids-toy-center'),
            'grid-layout'   => __('Grid Layout', 'kids-toy-center')
        ),
    ));

    $wp_customize->add_setting('kids_toy_center_archive_pagination_alignment',array(
        'default' => 'left-align',
        'sanitize_callback' => 'kids_toy_center_sanitize_pagination_alignment'
    ));
    $wp_customize->add_control('kids_toy_center_archive_pagination_alignment',array(
        'type' => 'select',
        'label' => __('Pagination Alignment','kids-toy-center'),
        'section' => 'kids_toy_center_post_layout_section',
        'choices' => array(
            'right-align' => __('Right Alignment','kids-toy-center'),
            'center-align' => __('Center Alignment','kids-toy-center'),
            'left-align' => __('Left Alignment','kids-toy-center'),
        ),
    ) );

     /** Post Layouts Ends */

    /** Post Settings */
    $wp_customize->add_section(
        'kids_toy_center_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'kids-toy-center' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_home_post_settings',
        )
    );

    // Excerpt Length
    $wp_customize->add_section(
        'kids_toy_center_post_excerpt_length', 
        array(    
            'title'       => __('Excerpt Length', 'kids-toy-center'),
            'panel'       => 'theme_option_panel'    
        )
    );

    $wp_customize->add_setting( 
        'kids_toy_center_post_excerpt_length', 
        array(
            'default'           => '20',
            'sanitize_callback' => 'kids_toy_center_sanitize_number_range',
    ) );
    $wp_customize->add_control( 
        'kids_toy_center_post_excerpt_length', 
        array(
            'label'       => esc_html__( 'Excerpt Length', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_post_settings',
            'type'        => 'number',
            'input_attrs' => array( 'min' => 1, 'max' => 200, 'style' => 'width: 100%;' ),
    ) );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'kids_toy_center_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'kids_toy_center_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'kids_toy_center_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'kids_toy_center_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_post_settings',
            'type'        => 'checkbox',
        )
    );
    
    // Add setting for Read More button
    $wp_customize->add_setting( 'kids_toy_center_read_more_setting', array(
        'default'           => true, // Default value (true for showing Read More button)
        'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
    ) );

    // Add control for Read More button
    $wp_customize->add_control( 'kids_toy_center_read_more_setting', array(
        'label'    => esc_html__( 'Show Read More Button', 'kids-toy-center' ),
        'section'  => 'kids_toy_center_post_settings',
        'type'        => 'checkbox',
    ) );

    $wp_customize->add_setting('kids_toy_center_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'kids_toy_center_sanitize_sortable',
    ));
    $wp_customize->add_control(new Kids_Toy_Center_Control_Sortable($wp_customize, 'kids_toy_center_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'kids-toy-center'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'kids-toy-center') ,
        'section' => 'kids_toy_center_post_settings',
        'choices' => array(
            'heading' => __('heading', 'kids-toy-center') ,
            'author' => __('author', 'kids-toy-center') ,
            'featured-image' => __('featured-image', 'kids-toy-center') ,
            'content' => __('content', 'kids-toy-center') ,
            'button' => __('button', 'kids-toy-center') ,
        ) ,
    )));

    /** Post Settings Ends */

    /** Single Post Settings */
    $wp_customize->add_section(
        'kids_toy_center_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'kids-toy-center' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_home_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'kids_toy_center_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'kids_toy_center_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('kids_toy_center_single_post_align',array(
        'default' => 'left-align',
        'sanitize_callback' => 'kids_toy_center_sanitize_single_post_align'
    ));
    $wp_customize->add_control('kids_toy_center_single_post_align',array(
        'type' => 'select',
        'label' => __('Single Post Alignment','kids-toy-center'),
        'section' => 'kids_toy_center_single_post_settings',
        'choices' => array(
            'left-align' => __('Left Alignment','kids-toy-center'),
            'right-align' => __('Right Alignment','kids-toy-center'),
            'center-align' => __('Center Alignment','kids-toy-center'),
        ),
    ) );
    /** Single Post Settings Ends */

        // Typography Settings Section
    $wp_customize->add_section('kids_toy_center_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'kids-toy-center'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'kids_toy_center_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'kids-toy-center'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('kids_toy_center_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'kids_toy_center_sanitize_choicess',
    ));
    $wp_customize->add_control('kids_toy_center_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'kids-toy-center'),
        'section' => 'kids_toy_center_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('kids_toy_center_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'kids_toy_center_sanitize_choicess',
    ));
    $wp_customize->add_control('kids_toy_center_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'kids-toy-center'),
        'section' => 'kids_toy_center_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'kids_toy_center_general_settings',
         array(
            'priority' => 12,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'kids-toy-center' ),
            'description' => esc_html__( 'Customize General Settings', 'kids-toy-center' ),
        ) 
    );
    
    /** General Settings */
    $wp_customize->add_section(
        'kids_toy_center_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'kids-toy-center' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'kids_toy_center_preloader_setting', 
        array(
            'default'           => false,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_preloader_setting',
        array(
            'label'       => __( 'Show / Hide Preloader', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_general_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('kids_toy_center_theme_width',array(
        'default' => 'full-width',
        'sanitize_callback' => 'kids_toy_center_sanitize_theme_width'
    ));
    $wp_customize->add_control('kids_toy_center_theme_width',array(
        'type' => 'select',
        'label' => __('Theme Width Option','kids-toy-center'),
        'section' => 'kids_toy_center_general_settings',
        'choices' => array(
            'full-width' => __('Fullwidth','kids-toy-center'),
            'container' => __('Container','kids-toy-center'),
            'container-fluid' => __('Container Fluid','kids-toy-center'),
        ),
    ) );

    /** General Settings Ends */

    /** Header Section Settings */
    $wp_customize->add_section(
        'kids_toy_center_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'kids-toy-center' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_home_page_settings',
        )
    );

    /** Header Section control */
    $wp_customize->add_setting( 
        'kids_toy_center_header_setting', 
        array(
            'default' => false ,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_header_setting',
        array(
            'label'       => __( 'Show Topbar', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_header_section_settings',
            'type'        => 'checkbox',
        )
    );

     /** Phone */
    $wp_customize->add_setting(
        'kids_toy_center_header_phone',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_header_phone',
        array(
            'label' => esc_html__( 'Add Phone', 'kids-toy-center' ),
            'section' => 'kids_toy_center_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('kids_toy_center_phone_icon',array(
        'default'   => 'fas fa-phone',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Kids_Toy_Center_Changeable_Icon(
        $wp_customize,'kids_toy_center_phone_icon',array(
        'label' => __('Phone Icon','kids-toy-center'),
        'transport' => 'refresh',
        'section'   => 'kids_toy_center_header_section_settings',
        'type'      => 'icon'
    )));

     /** Email */
    $wp_customize->add_setting(
        'kids_toy_center_header_email',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_header_email',
        array(
            'label' => esc_html__( 'Add Email', 'kids-toy-center' ),
            'section' => 'kids_toy_center_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('kids_toy_center_mail_icon',array(
        'default'   => 'fas fa-envelope',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Kids_Toy_Center_Changeable_Icon(
        $wp_customize,'kids_toy_center_mail_icon',array(
        'label' => __('Mail Icon','kids-toy-center'),
        'transport' => 'refresh',
        'section'   => 'kids_toy_center_header_section_settings',
        'type'      => 'icon'
    )));

    /** Appointment Button */
    $wp_customize->add_setting(
        'kids_toy_center_header_btn_text',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_header_btn_text',
        array(
            'label' => esc_html__( 'Add Button Text', 'kids-toy-center' ),
            'section' => 'kids_toy_center_header_section_settings',
            'type' => 'text',
        )
    );

    /** Appointment Button */
    $wp_customize->add_setting(
        'kids_toy_center_header_btn_url',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_header_btn_url',
        array(
            'label' => esc_html__( 'Add Button URL', 'kids-toy-center' ),
            'section' => 'kids_toy_center_header_section_settings',
            'type' => 'url',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'menu_font_weight', array(
        'default'           => '500',
        'sanitize_callback' => 'kids_toy_center_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'kids-toy-center' ),
        'section'  => 'kids_toy_center_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'kids-toy-center' ),
            '200' => __( '200 - Extra Light', 'kids-toy-center' ),
            '300' => __( '300 - Light', 'kids-toy-center' ),
            '400' => __( '400 - Normal', 'kids-toy-center' ),
            '500' => __( '500 - Medium', 'kids-toy-center' ),
            '600' => __( '600 - Semi Bold', 'kids-toy-center' ),
            '700' => __( '700 - Bold', 'kids-toy-center' ),
            '800' => __( '800 - Extra Bold', 'kids-toy-center' ),
            '900' => __( '900 - Black', 'kids-toy-center' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'menu_text_transform', array(
        'default'           => 'capitalize',
        'sanitize_callback' => 'kids_toy_center_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'kids-toy-center' ),
        'section'  => 'kids_toy_center_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'kids-toy-center' ),
            'capitalize' => __( 'Capitalize', 'kids-toy-center' ),
            'uppercase'  => __( 'Uppercase', 'kids-toy-center' ),
            'lowercase'  => __( 'Lowercase', 'kids-toy-center' ),
        ),
    ) );

    // Menu Hover Style	
    $wp_customize->add_setting('kids_toy_center_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'kids_toy_center_sanitize_choices'
	));
	$wp_customize->add_control('kids_toy_center_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','kids-toy-center'),
		'section' => 'kids_toy_center_header_section_settings',
		'choices' => array(
         'None' => __('None','kids-toy-center'),
         'Zoom In' => __('Zoom In','kids-toy-center'),
      ),
	));   

    /** Header Section Settings End */

    /** Socail Section Settings */
    $wp_customize->add_section(
        'kids_toy_center_social_section_settings',
        array(
            'title' => esc_html__( 'Social Media Section Settings', 'kids-toy-center' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_home_page_settings',
        )
    );

    /** Socail Section control */
    $wp_customize->add_setting( 
        'kids_toy_center_social_icon_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_social_icon_setting',
        array(
            'label'       => __( 'Show Social Icon', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_social_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'kids_toy_center_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_social_link_1',
        array(
            'label' => esc_html__( 'Add Facebook Link', 'kids-toy-center' ),
            'section' => 'kids_toy_center_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'kids_toy_center_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_social_link_2',
        array(
            'label' => esc_html__( 'Add Twitter Link', 'kids-toy-center' ),
            'section' => 'kids_toy_center_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'kids_toy_center_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_social_link_3',
        array(
            'label' => esc_html__( 'Add Instagram Link', 'kids-toy-center' ),
            'section' => 'kids_toy_center_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'kids_toy_center_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_social_link_4',
        array(
            'label' => esc_html__( 'Add Pintrest Link', 'kids-toy-center' ),
            'section' => 'kids_toy_center_social_section_settings',
            'type' => 'url',
        )
    );


    /** Social Section Settings End */

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'kids_toy_center_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'kids-toy-center' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'kids-toy-center' ),
        ) 
    );

    /** Slider Section Settings */
    $wp_customize->add_section(
        'kids_toy_center_slider_section_settings',
        array(
            'title' => esc_html__( 'Slider Section Settings', 'kids-toy-center' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'kids_toy_center_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'kids_toy_center_slider_setting', 
        array(
            'default' => true ,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_slider_setting',
        array(
            'label'       => __( 'Show Slider', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_slider_section_settings',
            'type'        => 'checkbox',
        )
    );

    $categories = get_categories();
        $cat_posts = array();
            $i = 0;
            $cat_posts[]='Select';
        foreach($categories as $category){
            if($i==0){
            $default = $category->slug;
            $i++;
        }
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'kids_toy_center_blog_slide_category',
        array(
            'default'   => 'select',
            'sanitize_callback' => 'kids_toy_center_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'kids_toy_center_blog_slide_category',
        array(
            'type'    => 'select',
            'choices' => $cat_posts,
            'label' => __('Select Category to display Slider Post','kids-toy-center'),
            'section' => 'kids_toy_center_slider_section_settings',
        )
    );

    /** About Section Settings */
    
    $wp_customize->add_section( 'kids_toy_center_section_featured_about',
        array(
        'title'      => __( 'Product Section', 'kids-toy-center' ),
        'priority'   => 110,
        'capability' => 'edit_theme_options',
        'panel'      => 'kids_toy_center_home_page_settings',
        )
    );

    /** Blog Section control */
    $wp_customize->add_setting( 
        'kids_toy_center_about_setting', 
        array(
            'default' => true ,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_about_setting',
        array(
            'label'       => __( 'Show Product Section', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_section_featured_about',
            'type'        => 'checkbox',
        )
    );

    // Section Title
    $wp_customize->add_setting('kids_toy_center_featured_mission_section_title', 
        array(
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('kids_toy_center_featured_mission_section_title', 
        array(
        'label'       => __('Section Title', 'kids-toy-center'),
        'section'     => 'kids_toy_center_section_featured_about',   
        'settings'    => 'kids_toy_center_featured_mission_section_title',
        'type'        => 'text'
        )
    );

    // Section Short Title
    $wp_customize->add_setting('kids_toy_center_featured_mission_section_short_title', 
        array(
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('kids_toy_center_featured_mission_section_short_title', 
        array(
        'label'       => __('Section Short Title', 'kids-toy-center'),
        'section'     => 'kids_toy_center_section_featured_about',   
        'settings'    => 'kids_toy_center_featured_mission_section_short_title',
        'type'        => 'text'
        )
    );

// Fetch product categories for Customizer
$kids_toy_center_args = array(
    'type'         => 'product',
    'orderby'      => 'term_group',
    'order'        => 'ASC',
    'hide_empty'   => false,
    'hierarchical' => 1,
    'taxonomy'     => 'product_cat',
);

$categories             = get_categories( $kids_toy_center_args );
$kids_toy_center_cats   = array();
$i                      = 0;

foreach ( $categories as $category ) {
    if ( $i == 0 ) {
        $default = $category->slug;
        $i++;
    }
    $kids_toy_center_cats[ $category->slug ] = $category->name;
}

// Customizer setting
$wp_customize->add_setting(
    'kids_toy_center_trending_post_slider_args',
    array(
        'default'           => 'select',
        'sanitize_callback' => 'kids_toy_center_sanitize_choices',
    )
);

// Customizer control
$wp_customize->add_control(
    'kids_toy_center_trending_post_slider_args',
    array(
        'type'     => 'select',
        'choices'  => $kids_toy_center_cats,
        'label'    => __( 'Select Category to display Tab Details', 'kids-toy-center' ),
        'section'  => 'kids_toy_center_section_featured_about',
    )
);

    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'kids_toy_center_footer_section',
        array(
            'title' => __( 'Footer Settings', 'kids-toy-center' ),
            'priority' => 70,
            'panel' => 'kids_toy_center_home_page_settings',
        )
    );

    /** Footer Widget Columns */
    $wp_customize->add_setting('kids_toy_center_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'kids_toy_center_sanitize_choices',
    ));

    $wp_customize->add_control('kids_toy_center_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'kids-toy-center'),
        'section'  => 'kids_toy_center_footer_section',
        'settings' => 'kids_toy_center_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'kids-toy-center'),
		   '2'     => __('Two', 'kids-toy-center'),
		   '3'     => __('Three', 'kids-toy-center'),
		   '4'     => __('Four', 'kids-toy-center')
        ),
    ));

    /** Copyright Text */
    $wp_customize->add_setting(
        'kids_toy_center_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'kids_toy_center_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'kids-toy-center' ),
            'section' => 'kids_toy_center_footer_section',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );


    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'kids-toy-center'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'kids-toy-center'), 1024, 800),
                'section' => 'kids_toy_center_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('kids_toy_center_background_attachment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'kids_toy_center_sanitize_choices',
    ));

    $wp_customize->add_control('kids_toy_center_background_attachment', array(
        'label'    => __('Footer Background Attachment', 'kids-toy-center'),
        'section'  => 'kids_toy_center_footer_section',
        'settings' => 'kids_toy_center_background_attachment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','kids-toy-center'),
            'scroll' => __('scroll','kids-toy-center'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'kids-toy-center'),
                'section' => 'kids_toy_center_footer_section',
                'type' => 'color',
            )
        )
    );

    /** Scroll To Top control */
    $wp_customize->add_setting( 
        'kids_toy_center_scroll_to_top', 
        array(
            'default'           => true,
            'sanitize_callback' => 'kids_toy_center_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'kids_toy_center_scroll_to_top',
        array(
            'label'       => __( 'Show / Hide Scroll To Top', 'kids-toy-center' ),
            'section'     => 'kids_toy_center_footer_section',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('kids_toy_center_scroll_button_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Kids_Toy_Center_Changeable_Icon(
        $wp_customize,'kids_toy_center_scroll_button_icon',array(
        'label' => __('Scroll Top Icon','kids-toy-center'),
        'transport' => 'refresh',
        'section'   => 'kids_toy_center_footer_section',
        'type'      => 'icon'
    )));

    $wp_customize->add_setting('kids_toy_center_scroll_top_alignment',array(
        'default' => 'right-align',
        'sanitize_callback' => 'kids_toy_center_sanitize_scroll_top_alignment'
    ));
    $wp_customize->add_control('kids_toy_center_scroll_top_alignment',array(
        'type' => 'select',
        'label' => __('Scroll Top Alignment','kids-toy-center'),
        'section' => 'kids_toy_center_footer_section',
        'choices' => array(
            'right-align' => __('Right Alignment','kids-toy-center'),
            'center-align' => __('Center Alignment','kids-toy-center'),
            'left-align' => __('Left Alignment','kids-toy-center'),
        ),
    ) );

    /** Scroll to top button shape */
    $wp_customize->add_setting('kids_toy_center_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'kids_toy_center_sanitize_choices',
    ));

    $wp_customize->add_control('kids_toy_center_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'kids-toy-center'),
        'section'  => 'kids_toy_center_footer_section',
        'settings' => 'kids_toy_center_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'kids-toy-center' ),
            'curved-box' => __( 'Curved Box', 'kids-toy-center' ),
            'circle'     => __( 'Circle', 'kids-toy-center' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'kids_toy_center_404_section',
        array(
            'title' => __( '404 Page Settings', 'kids-toy-center' ),
            'priority' => 70,
            'panel' => 'kids_toy_center_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'kids-toy-center'),
        'section' => 'kids_toy_center_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'kids-toy-center'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'kids-toy-center'),
        'section' => 'kids_toy_center_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'kids-toy-center'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'kids-toy-center'),
        'section' => 'kids_toy_center_404_section',
    ));
    /** Footer control END */
}
add_action( 'customize_register', 'kids_toy_center_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function kids_toy_center_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $kids_toy_center_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $kids_toy_center_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'kids_toy_center_customizer', get_template_directory_uri() . '/js' . $kids_toy_center_build . '/customizer' . $kids_toy_center_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'kids_toy_center_customize_preview_js' );